<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Pages"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / March 2013

*/

if (!defined('CPO')) exit;
$translator->addTranslation('navigation',CPO_BASEDIR.$moduleDirectory.'/lang');
$translator->addTranslation('pages',CPO_BASEDIR.$moduleDirectory.'/lang');

if (!function_exists('tocPagesHelp')) {
	function tocPagesHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

$GLOBALS['modules']['Pages'] = array(
	'directory'=>$moduleDirectory,
    'install'=>'function: Pages_install',
    'activate'=>'function: Pages_activate',
    'deactivate'=>'function: Pages_deactivate',
    'uninstall'=>'function: Pages_uninstall '.$moduleDirectory,
    'manage'=>'function: Pages_manage',
	//Help ***********************************+
	'helptoc' => array(
        'bersicht' 
			=> tocPagesHelp('index','pages'),
        '1. Eigenschaften' 
			=> tocPagesHelp('features','pages'),
        '2. Installation' 
			=> tocPagesHelp('setup','pages'),
        '3. Einstellungen' 
			=> tocPagesHelp('settings','pages'),
        '4. Anwendung' 
			=> tocPagesHelp('application','pages')
	),

	'gzip'=>'no',
	'meta-tags'=>'no',
	'debug'=>'no',
	'owner'		=>$cpoSystem['owner'],
	'lkey'		=>'',
	'mod_id'	=> 6,

	'key'=>'value'
	);
// Hier kommen die Basis-Funktionen ***************************************************************

if (!function_exists('log_pages')) {
	function log_pages()
	{
		global $cpoSystem;
		@mail('kontakt@conpresso4.de','Das Modul Pages wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
	}
}

function Pages_install()
{
	global $dbPrefix, $db;
	include (CPO_BASEDIR.$GLOBALS['modules']['Pages']['directory'].'/includes/setup.inc.php');
    $GLOBALS['message'][] = __('The pages-template-module got installed.');
	$pagesdb = new DB;
	$pagesdb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('pages', '".serialize(array("installed"=>time()))."', '') ");
	log_pages();
}

function Pages_activate()
{
    $GLOBALS['message'][] = __('The pages-template-module got activated.');
}

function Pages_deactivate()
{
    $GLOBALS['message'][] = __('The pages-template-module got deactivated.');
}

function Pages_uninstall($moduleDirectory)
{
	global $dbPrefix, $db;
	$query = "DROP TABLE IF EXISTS ".$dbPrefix."_mod_pages;";
	$db->query($query);
    $GLOBALS['message'][] .= sprintf(__('The module was removed from the ConPresso-system. To finally uninstall the module, please remove the module directory <i>%s</i>.'), $moduleDirectory);
}

function Pages_manage()
{
	global $dbPrefix, $db, $k, $module_status, $newsletter_rubric_id;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['Pages']['directory'].'/edit.php"><img src="'.SKIN_URL.'pic_edit.gif" title="'.__('work on page templates').'" alt="'.__('work on page templates').'"></a>';
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['Pages']['directory'].'/settings.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('settings').'" alt="'.__('settings').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_edit.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}
if (!$activeModules['Pages']['installed'])  {
	$pagesdb = new DB;
	$pagesdb->query('SELECT options FROM '.CPO_OPTION.' '
			  ."WHERE type='pages' ORDER BY id ASC LIMIT 0,1");
	while ($pagesdb->next_record()) {
		$options = $pagesdb->v('options');
		$pagesOpt = unserialize($options);
		if (!is_array($pagesOpt)) break;
		foreach ($pagesOpt as $key=>$v) {
			$activeModules['Pages'][$key] = $v;
		}
	}
}
$pagebreak = false;
if (license($activeModules['Pages']['installed'],$activeModules['Pages']['mod_id']) !== false) {
	$message['license'] = '<strong>Invalid License!</strong>';
	$pagebreak = true;
}
if (	license($activeModules['Pages']['lkey'],$activeModules['Pages']['mod_id']) != 1 &&
		license($activeModules['Pages']['lkey'],$activeModules['Pages']['mod_id']) != 2 &&
		license($activeModules['Pages']['lkey'],$activeModules['Pages']['mod_id']) != 3 &&
		$activeModules['Pages']['installed']<(time()-90*24*60*60) && 
		!isset($_POST['go']) &&
		@file_exists(CPO_BASEDIR.$activeModules['Pages']['directory'].'/includes/producer.inc.php')
	) 
	{
	include(CPO_BASEDIR.$activeModules['Pages']['directory'].'/includes/producer.inc.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	$pagebreak = true;
}

if (!function_exists('PagesProcess') && !$pagebreak) {
	function PagesProcess($code)  {
		global $mod_css_string;
		$find_php_regexp = "/<\?\s*php\s*(.*?)\s*\?>/smi";
		preg_match_all($find_php_regexp, $code, $treffer);
		$html_string = preg_split($find_php_regexp, $code);
		for($i=0;$i<count($html_string);$i++)  {
			echo $html_string[$i];
			$phpcode = trim($treffer[1][$i]);
			if (substr($phpcode,-1) != ";") $phpcode .= ";";
			eval ($phpcode);
		}
	}
}
if (array_key_exists('Pages',$activeModules)) {  // the CPO4.1 PageTemplate-Functions
	function cpoPageEcho($var)  { 
        $var = str_replace(';','',$var);
		global $$var; 
		return $$var; 
	}
	function cpoPageRubricSettings($var)  {
        global $cpoRubricSettings;
        $var = str_replace(';','',$var);
		return $cpoRubricSettings[$var]; 
	}
}

?>
