<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Pages"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / March 2013

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php');
$help = $activeModules['Pages']['help'];

// Sprache
$directory = basename(dirname($_SERVER['PHP_SELF'])); 
//$translator->addTranslation('pages',CPO_BASEDIR.$directory.'/lang');

if (!function_exists(PagesListFiles))
{
	function PagesListFiles($dir,$m)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file))  {
				echo "<a href=\"".$PHP_SELF."?filedelete=".$dir.$file."\"><img src=\"del.gif\" border=\"0\" alt=\"Datei lschen\"></a>&nbsp;".$m."<img src=\"file.gif\"> <a href='".$dir.$file."' target=\"_blank\">".$file."</a><BR>";
			}
		}
		closedir($h);
	}
}

if (!function_exists(getPagesTemplatesDirList))
{
	function getPagesTemplatesDirList($base,$selectboxname,$selected)  {
		if(is_dir($base)){
			$dh = opendir($base);
			$m = 1;
			$count=0;
			echo "\n\n<!-- ---------------- Selectbox (Verzeichnis: ".$base." ) -------------- //-->\n";
			echo "<select id=\"template_select\" name=\"".$selectboxname."\" onChange=\"document.modulesettings.template_selected.value=document.modulesettings.template_select.value;document.modulesettings.preview.src='templates/'+document.modulesettings.template_select.value+'/preview.gif'\">\n";
			echo '<option value="">--' . __('choose') . '--</option>';
			while (false !== ($dir = readdir($dh))) {
				if (is_dir($base . $dir) && $dir !== '.' && $dir !== '..') {
					$select_string = '';
					if ($dir==$selected) $select_string = 'selected="selected"';
					echo '<option value="' . $dir . '"' . $select_string . '>' . $dir . '</option>';
					$count+=1;
					$m += 1;
				} else {
					next;
				}
			}
			PagesListFiles($base,"&nbsp;");
			closedir($dh);
			echo "</select>\n";
		} else {
			print "Ist kein Verzeichnis!";
		}
		return $count;
	}
}

include('includes/actions.inc.php');

// Seitenausgabe ********************************************************

// Header
require(CPO_BASEDIR.'_include/header.php');

	$rubric_header = array();

	$query = "SELECT header, footer, css FROM ".$dbPrefix."_mod_pages WHERE id=0";  // the globals
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    $db->next_record();

	$global_header = htmlentities($db->v('header'), ENT_COMPAT, 'ISO-8859-15');
	$global_footer = htmlentities($db->v('footer'), ENT_COMPAT, 'ISO-8859-15');
	$global_css = htmlentities($db->v('css', ENT_COMPAT, 'ISO-8859-15'));

	$query = "SELECT * FROM ".$dbPrefix."_mod_pages";  // the globals
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    while ($db->next_record()):
		$local_id[] = htmlentities($db->v('id'), ENT_COMPAT, 'ISO-8859-15');
		$local_header[] = htmlentities($db->v('header'), ENT_COMPAT, 'ISO-8859-15');
		$local_footer[] = htmlentities($db->v('footer'), ENT_COMPAT, 'ISO-8859-15');
		$local_css[] = htmlentities($db->v('css'), ENT_COMPAT, 'ISO-8859-15');
		$local_default[] = htmlentities($db->v('def_rubric'), ENT_COMPAT, 'ISO-8859-15');
		$local_using[] = htmlentities($db->v('use_rubric'), ENT_COMPAT, 'ISO-8859-15');
	endwhile;


	$query = "SELECT id, name FROM ".$dbPrefix."_rubric";  // the globals
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    while ($db->next_record()):
		$rubric_id[] = htmlentities($db->v('id'), ENT_COMPAT, 'ISO-8859-15');
		$rubric_name[] = htmlentities($db->v('name'), ENT_COMPAT, 'ISO-8859-15');
	endwhile;

	for ($r=0;$r<count($rubric_id);$r++)  {
		for ($i=0;$i<count($local_id);$i++)  {
			if ($local_id[$i] == $rubric_id[$r])  {
				$rubric_names[$rubric_id[$r]] = $rubric_name[$r];
				$rubric_header[$rubric_id[$r]] = $local_header[$i];
				$rubric_footer[$rubric_id[$r]] = $local_footer[$i];
				$rubric_css[$rubric_id[$r]] = $local_css[$i];
				$rubric_default[$rubric_id[$r]] = $local_default[$i];
				$rubric_using[$rubric_id[$r]] = $local_using[$i];
			}
		}
	}


	$query = "SELECT id FROM ".$dbPrefix."_mod_pages WHERE def_rubric = 1 AND use_rubric = 0";  // the defaults
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    while ($db->next_record()):
		$def_rubrics_id[] = htmlentities($db->v('id'), ENT_COMPAT, 'ISO-8859-15');
		$def_rubrics_name[] = htmlentities($rubric_names[$db->v('id')], ENT_COMPAT, 'ISO-8859-15');
	endwhile;

?>

<script type="text/javascript"> 
<!-- 
	function textarea (boxid, link){ 
		var t=document.getElementById(boxid); 
		if(link.innerHTML=='<?php echo __('enlarge'); ?>'){ 
			t.style.height = t.offsetHeight+250+"px"; 
			link.innerHTML='<?php echo __('reduce'); ?>'; 
		} else{ 
			t.style.height = t.offsetHeight-250+"px"; 
			link.innerHTML='<?php echo __('enlarge'); ?>'; 
		} 
	} 
//--> 
</script> 

<?php



		printPageHeader(
			__('Page templates'),
			__('In this view you can work on the page and rubric headers and footers.'),
			tocPagesHelp('settings','pages'),
			true,
			'modules'
		);

		require(CPO_BASEDIR."_include/message.php");

// ******* the Templates ************************************************************************
		
		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
		echo '<input type="hidden" name="go" value="1">';
		echo '<input type="hidden" name="list" value="options">';

// ******** GLOBAL TEMPLATES ***************
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Page header and footer').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Global header:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="20" class="text inputwidth" name="cpoPageHeader[0]" id="cpoPageHeader0" style="width: 95%; height: 100px;">'.$global_header.'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageHeader0\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Global footer:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="20" class="text inputwidth" name="cpoPageFooter[0]" id="cpoPageFooter0" style="width: 95%; height: 100px;">'.$global_footer.'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageFooter0\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Global CSS:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="20" class="text inputwidth" name="cpoPageCSS[0]" id="cpoPageCSS0" style="width: 95%; height: 100px;">'.$global_css.'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageCSS0\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';

		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save global templates').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

// ******* Reload Template ************************************************************************
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Load template').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Template base:');
            echo '</td>';
            echo '<td class="rightrow">';
			$dir="templates/";
			getPagesTemplatesDirList($dir,"cpoPagesNew[template_dir]",$activeModules['Pages']['template_dir']); 
			echo '<script language="Javascript" type="text/javascript">';
			echo 'function set_defaults() { ';
			echo 'dir = document.modulesettings.template_selected.value;';
			echo 'if (confirm(\''.__('Do you really want to reset all design settings to the chosen template?').'\')) { ';
			echo 'location.href="edit.php?list=options&default=" + dir; } }';
			echo '</script>';
            echo ' <input type="hidden" name="template_selected" value=""><a href="javascript:set_defaults();"><img src="'.BASE_ABS.'_skin/conpresso/pic_mod_active_on.gif" alt="'.__('reload').'" title="'.__('reload').'"></a><br />';
			echo '<img src="templates/preview.gif" name="preview" />';
			echo '<br />'.__('Using the reset option resets all your individual settings to the defaults by reloading the chosen template!');
			echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

// ******* Save Template ************************************************************************
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Save template').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Template name:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text" name="cpoPagesCustom" value="" size="30" maxlength="255">&nbsp;';
            echo '<input type="submit" class="button" name="action" value="'.__('Save custom preset').'">';
			echo '</td>';
		echo '</tr>';
		$query = "SELECT id, use_rubric FROM ".$dbPrefix."_mod_pages WHERE id < '0' ORDER BY use_rubric ";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query); 
		while($db->next_record()) {
			$preset_id  = $db->v('id');
			$preset_name = $db->v('use_rubric');
			echo '<tr>';
				echo '<td class="leftrow">';
				echo '&nbsp;';
				echo '</td>';
				echo '<td class="rightrow">';
				echo '<a href="edit.php?preset=load&id='.$preset_id.'" onClick="return confirm(\''.__('Do you really want to load this preset?').'\')">';
				echo '<img src="'.BASE_ABS.'_skin/conpresso/pic_mod_active_off.gif" alt="'.__('load custom preset').'" title="'.__('load custom preset').'" align="absmiddle"></a>';
				echo '<a href="edit.php?preset=delete&id='.$preset_id.'" onClick="return confirm(\''.__('Do you really want to delete this preset?').'\')">';
				echo '<img src="'.BASE_ABS.'_skin/conpresso/pic_del.gif" alt="'.__('delete custom preset').'" title="'.__('delete custom preset').'" align="absmiddle"></a> ';
				echo $preset_name.'<BR>';
				echo '</td>';
			echo '</tr>';
		}

		echo '</tbody></table>';

echo '<div class="header"><h3>'.__('Rubric templates').'</h3>';
echo __('The following templates allow individual designs for a single or even each rubric. They are processed between the global header and the content and between the content and the global footer. For completly different appearences leave the page header and footer empty and use only the rubric templates. In other words: everything that stays the same on each page of your website should be placed in the section above, everything individual in the section below this text.').'</div>';

// ******** RUBRIC TEMPLATES ***************
		// fetch all rubrics to show the ones not in navigation
		$query = 'SELECT id, name, seclevel '
				.'FROM '.CPO_RUBRIC.' '
				.'ORDER BY name';
		DEBUG(1, $query, __FILE__, __LINE__);
		$db->query($query);
		$notInNavigation = array();
		while ($db->next_record()) {
			$notInNavigation[$db->v('id')] = array(
				'id'=>0,
				'l'=>0,
				'r'=>0,
				'level'=>1,
				'childs'=>0,
				'caption'=>'',
				'navigation'=>array(),
				'rubric'=>array('id'=>$db->v('id'), 'name'=>$db->v('name'), 'seclevel'=>$db->v('seclevel'), )
			);
		}
	$navigation = getNavigation();
	foreach ($navigation as $k=>$v) {
		if (!is_numeric($v['rubric']['id']))  continue;

		if (array_key_exists($v['rubric']['id'], $notInNavigation)) unset($notInNavigation[$v['rubric']['id']]);

		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>' . __('Header and footer of rubric:') . ' ' . $v['rubric']['name'] . '  (' . $v['caption'] . ') (' . $v['rubric']['id'] . ')</span></th>';

		echo '</tr></thead><tbody>';
        // }}}
	if ($rubric_using[$v['rubric']['id']] != 0) echo "\n<!--\n";
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Rubric header:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="10" class="text inputwidth" name="cpoPageHeader['.$v['rubric']['id'].']" id="cpoPageHeader'.$v['rubric']['id'].'" style="width: 95%; height: 50px;">'.$rubric_header[$v['rubric']['id']].'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageHeader'.$v['rubric']['id'].'\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Rubric footer:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="10" class="text inputwidth" name="cpoPageFooter['.$v['rubric']['id'].']" id="cpoPageFooter'.$v['rubric']['id'].'" style="width: 95%; height: 50px;">'.$rubric_footer[$v['rubric']['id']].'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageFooter'.$v['rubric']['id'].'\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Rubric CSS:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="10" class="text inputwidth" name="cpoPageCSS['.$v['rubric']['id'].']" id="cpoPageCSS'.$v['rubric']['id'].'" style="width: 95%; height: 50px;">'.$rubric_css[$v['rubric']['id']].'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageCSS'.$v['rubric']['id'].'\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use as sample:');
            echo '</td>';
            echo '<td class="rightrow">';
 			$yes_selected = '';
			$no_selected = '';
			if ($rubric_default[$v['rubric']['id']] == '1')  $yes_selected = ' selected="selected"';
			if ($rubric_default[$v['rubric']['id']] == '0')  $no_selected = ' selected="selected"';
            echo '<select name="cpoPageDefault['.$v['rubric']['id'].']">';
			echo '<option value="0"'.$no_selected.'>'.__('no').'</option>';
			echo '<option value="1"'.$yes_selected.'>'.__('yes').'</option>';
            echo '</select>';
           echo '</td>';
		echo '</tr>';
	if ($rubric_using[$v['rubric']['id']] != 0) echo "\n-->\n";

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use template of:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<select name="cpoPageUsing['.$v['rubric']['id'].']">';
			$own_selected = ($rubric_using[$v['rubric']['id']] == 0) ? ' selected="selected"': '';
			echo '<option value="0"'.$own_selected.'>'.__('own').'</option>';
			for ($i=0;$i<count($def_rubrics_id);$i++)  {
				$selected = ($rubric_using[$v['rubric']['id']] == $def_rubrics_id[$i]) ? ' selected="selected"': '';
				if ($v['rubric']['id'] != $def_rubrics_id[$i]) echo '<option value="'.$def_rubrics_id[$i].'"'.$selected.'>'.$def_rubrics_name[$i].'</option>';
			}
            echo '</select>';
           echo '</td>';
		echo '</tr>';

		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save rubric templates of rubric ').$v['rubric']['name'].'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';
	}

	foreach ($notInNavigation as $k=>$v) {
		if (!is_numeric($v['rubric']['id']))  continue;
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>' . __('Header and footer of rubric:') . ' ' . $v['rubric']['name'] . '  (' . __('Not in navigation') . ') (' . $v['rubric']['id'] . ')</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

	if ($rubric_using[$v['rubric']['id']] != 0) echo "\n<!--\n";
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Rubric header:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="10" class="text inputwidth" name="cpoPageHeader['.$v['rubric']['id'].']" id="cpoPageHeader'.$v['rubric']['id'].'" style="width: 95%; height: 50px;">'.$rubric_header[$v['rubric']['id']].'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageHeader'.$v['rubric']['id'].'\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Rubric footer:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="10" class="text inputwidth" name="cpoPageFooter['.$v['rubric']['id'].']" id="cpoPageFooter'.$v['rubric']['id'].'" style="width: 95%; height: 50px;">'.$rubric_footer[$v['rubric']['id']].'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageFooter'.$v['rubric']['id'].'\', this);return false" id="lnk">'.__('enlarge').'</a>';
           echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Rubric CSS:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea rows="10" class="text inputwidth" name="cpoPageCSS['.$v['rubric']['id'].']" id="cpoPageCSS'.$v['rubric']['id'].'" style="width: 95%; height: 50px;">'.$rubric_css[$v['rubric']['id']].'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'cpoPageCSS'.$v['rubric']['id'].'\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use as sample:');
            echo '</td>';
            echo '<td class="rightrow">';
 			$yes_selected = '';
			$no_selected = '';
			if ($rubric_default[$v['rubric']['id']] == '1')  $yes_selected = ' selected="selected"';
			if ($rubric_default[$v['rubric']['id']] == '0')  $no_selected = ' selected="selected"';
            echo '<select name="cpoPageDefault['.$v['rubric']['id'].']">';
			echo '<option value="0"'.$no_selected.'>'.__('no').'</option>';
			echo '<option value="1"'.$yes_selected.'>'.__('yes').'</option>';
            echo '</select>';
           echo '</td>';
		echo '</tr>';
	if ($rubric_using[$v['rubric']['id']] != 0) echo "\n-->\n";

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use template of:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<select name="cpoPageUsing['.$v['rubric']['id'].']">';
			$own_selected = ($rubric_using[$v['rubric']['id']] == 0) ? ' selected="selected"': '';
			echo '<option value="0"'.$own_selected.'>'.__('own').'</option>';
			for ($i=0;$i<count($def_rubrics_id);$i++)  {
				$selected = ($rubric_using[$v['rubric']['id']] == $def_rubrics_id[$i]) ? ' selected="selected"': '';
				if ($v['rubric']['id'] != $def_rubrics_id[$i]) echo '<option value="'.$def_rubrics_id[$i].'"'.$selected.'>'.$def_rubrics_name[$i].'</option>';
			}
            echo '</select>';
           echo '</td>';
		echo '</tr>';

		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save rubric templates of rubric ').$v['rubric']['name'].'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';
	}
	echo '</form>';

// ==== footer =====
include('includes/producer.inc.php');
include(CPO_BASEDIR.'_include/footer.php');

?>