<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Pages"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / March 2013

*/

// Modulaktionen

// defaults aus template laden
if (isset($_GET['default'])) {
	// header
	if (file_exists("templates/" . $_GET['default'] . "/global_header.php"))  {
		$_POST['cpoPageHeader'][0] = file_get_contents ("templates/" . $_GET['default'] . "/global_header.php");
	} else {
		$message[] = '<b>'.__('Warning: ').'</b>'.__('No header infomation for this template available!');
	}
	// footer
	if (file_exists("templates/" . $_GET['default'] . "/global_footer.php"))  {
		$_POST['cpoPageFooter'][0] = file_get_contents ("templates/" . $_GET['default'] . "/global_footer.php");
	} else {
		$message[] = '<b>'.__('Warning: ').'</b>'.__('No footer infomation for this template available!');
	}
	// css
	if (file_exists("templates/" . $_GET['default'] . "/style.css"))  {
		$_POST['cpoPageCSS'][0] = file_get_contents ("templates/" . $_GET['default'] . "/style.css");
	} else {
		$message[] = '<b>'.__('Warning: ').'</b>'.__('No css infomation for this template available!');
	}

	$_POST['cpoPageUsing'] = array();
	$_POST['go'] = true;
}

// Templates speichern
if (isset($_POST['go'])) {
	// global header, footer und css speichern
	$query = "UPDATE ".$dbPrefix."_mod_pages SET ";
	$query .= "header = '".		addslashes($_POST['cpoPageHeader'][0])	."', ";
	$query .= "footer = '".		addslashes($_POST['cpoPageFooter'][0])	."', ";
	$query .= "css = '".		addslashes($_POST['cpoPageCSS'][0])	."' ";
	$query .= "WHERE id = 0";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query); 
	foreach ($_POST['cpoPageUsing'] as $k=>$v) {  // die Rubriken
		$query = sprintf(
			 "REPLACE INTO ".$dbPrefix."_mod_pages (id, header, footer, css, def_rubric, use_rubric) VALUES ('%s', '%s', '%s', '%s', '%s', '%s')", 
			$k,
			addslashes($_POST['cpoPageHeader'][$k]),
			addslashes($_POST['cpoPageFooter'][$k]),
			addslashes($_POST['cpoPageCSS'][$k]),
			addslashes($_POST['cpoPageDefault'][$k]),
			addslashes($_POST['cpoPageUsing'][$k])
		);
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query); 
    }

    $message[] = __('Template settings were updated!');
}

// Templates als Vorlage speichern
if (!empty($_POST['cpoPagesCustom'])) {
//	print_r($_POST);
	$query = "SELECT min(id) AS lowest FROM ".$dbPrefix."_mod_pages";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    $db->next_record();
	$newID = $db->v('lowest')-1;

	$query = "SELECT header, footer, css FROM ".$dbPrefix."_mod_pages WHERE id=0";  // the globals
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    $db->next_record();

	// global header, footer und css als Vorlagespeichern
		$query = sprintf(
			 "INSERT INTO ".$dbPrefix."_mod_pages (id, header, footer, css, def_rubric, use_rubric) VALUES ('%s', '%s', '%s', '%s', '%s', '%s')", 
			$newID,
			addslashes($db->v('header')),
			addslashes($db->v('footer')),
			addslashes($db->v('css')),
			0,
			addslashes($_POST['cpoPagesCustom'])
		);
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query); 

    $message[] = __('Template was saved as preset!');
}

// Templates lschen oder laden
if (isset($_GET['preset'])) {
	if ($_GET['preset'] == "delete")  {
		$query = "DELETE FROM ".$dbPrefix."_mod_pages WHERE id = '".$_GET['id']."' ";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query);
	    $message[] = __('The custom preset was successfully deleted');
	}
	if ($_GET['preset'] == "load")  {
		$query = "SELECT header, footer, css FROM ".$dbPrefix."_mod_pages WHERE id = '".$_GET['id']."' ";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query);
	    $db->next_record();
		$query = "UPDATE ".$dbPrefix."_mod_pages SET header='".addslashes($db->v('header'))."', footer='".addslashes($db->v('footer'))."', css='".addslashes($db->v('css'))."' WHERE id = '0' ";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query);
	    $message[] = __('The custom preset was successfully loaded');
	}
}


// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen) ************************
if (isset($_POST['save'])) {
	$new_settings = ($_POST) ? $_POST : $_GET ;
    foreach ($activeModules['Pages'] as $k=>$v) {
        if (!isset($_POST['cpoPagesNew'][$k])) continue;
        if (is_bool($activeModules['Pages'][$k])) {
            $activeModules['Pages'][$k] = (bool) $_POST['cpoPagesNew'][$k];
        } else  {
			$activeModules['Pages'][$k] = $_POST['cpoPagesNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoPagesNew'])) unset($new_settings['cpoPagesNew'][$k]);
    }
	if (isset($new_settings['cpoPagesNew']))  {
		foreach ($new_settings['cpoPagesNew'] as $k=>$v) {
			$activeModules['Pages'][$k] = $new_settings['cpoPagesNew'][$k];
		}
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = 'Pages'", 
            addslashes(serialize($activeModules['Pages']))
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
}

?>