<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id: index.php,v 1.11 2005/07/10 22:26:57 balu Exp $ */

// mod_pages ***************************************************
include(CPO_BASEDIR.$activeModules['Pages']['directory'].'/includes/pages_data.inc.php');
// mod_pages ***************************************************


// create a regular expression with all available placeholders
$pageTagsPreg = '/<!--\s*(page|value|function)\s*:\s*([^;]*?)\s*(;\s*(.*?)\s*)?-->/si';

preg_match_all($pageTagsPreg, $pageTemplate, $pageMatches, PREG_SET_ORDER);
foreach ($pageMatches as $match) {
    $page_fullmatch = $match[0];
    $page_type      = strtolower(trim($match[1]));
    $page_name      = preg_replace("/(\r\n|\n|\r)/", ' ', trim($match[2]));
    $key            = $page_name.' ('.$page_type.')';
    $_params        = '';
    if (isset($match[4])) $_params = preg_replace("/(\r\n|\n|\r)/", ' ', trim($match[4]));

    // create an array with all parameters
    $prefix = '';
    $pageparameters = array();
    foreach (explode(';', $_params) as $value) {
        if (substr($value, -1)=='\\') {
            $prefix .= substr($value, 0, -1).';';
            continue;
        }
        $value = trim($prefix.$value);
        $prefix = '';
        if ($value=='') continue;

        // split 'a = b' or only 'a'
        preg_match('/\s*([^=]*)\s*(=(.*))?/', $value, $tmp);

        // no matches found?
        if (count($tmp)==0) continue;

        if (count($tmp)==2) { // only a flag
            $pageparameters[strtolower(trim($tmp[1]))] = true;
        }
        if (count($tmp)==4) { // a = b
            $pageparameters[strtolower(trim($tmp[1]))] = trim($tmp[3]);
        }
    }

    // create a replacement for the tag
    $pagereplacement = '<br />{{{{ ERROR: unable to find replacement for the following placeholder (unknown type?): }}}'.htmlspecialchars($page_fullmatch, ENT_COMPAT, 'ISO-8859-15')."<br />";

    switch ($page_type) {
    case 'page': // {{{
        switch (strtolower($page_name)) {
        case 'articles': // {{{
            $rubricId = $cpoRubric['id'];
            if (array_key_exists('id', $pageparameters)) {
                $rubricId = (int)$pageparameters['id'];
            }
            $_pagetype = $pagetype;
            if (array_key_exists('pagetype', $pageparameters)) {
                $_pagetype = $pageparameters['pagetype'];
            }

            $pos = 0;
            if (!empty($_REQUEST['pos'])) {
                $pos = (int)$_REQUEST['pos'];
            }
            if ($_pagetype=='php') {
                $pos = 0;
            }
            if (array_key_exists('pos', $pageparameters) && $pageparameters['pos']>0) {
                $pos = $pageparameters['pos'];
            }

            $cpoRubricOverride = array();
            if (array_key_exists('noofarticles', $pageparameters)) {
                $cpoRubricOverride['settings']['noOfArticles'] = $pageparameters['noofarticles'];
            }

            if (array_key_exists('sorting', $pageparameters)) {
                $cpoRubricOverride['settings']['sorting'] = $pageparameters['sorting'];
            }

            if (!empty($hdlr_buildpage_articles) && !array_key_exists('id', $pageparameters)) {
                ob_start();
                doActions($hdlr_buildpage_articles);
                $pagereplacement = ob_get_clean();
            } else {
                $pagereplacement = getArticles($rubricId, $_pagetype, $pos, $cpoRubricOverride);
            }
            break; // }}}
        case 'navigation': // {{{
            //printNavigation($navi = '', $activeRubric = 0, $levels = 99, $parent = 0, $activeOnly = false, $target = '');
            $levels = 99;
            if (array_key_exists('levels', $pageparameters)) {
                $levels = (int)$pageparameters['levels'];
            }
            $parent = 0;
            if (array_key_exists('parent', $pageparameters)) {
                if (substr($pageparameters['parent'], 0, 2)!='ae') {
                    $parent = (int)$pageparameters['parent'];
                } else {
                    $level = (int)substr($pageparameters['parent'], 2);
                    $ae = getActiveElements();
                    if (!isset($ae[$level])) {
                        $pagereplacement = '<!-- Navigation level '.$level.' not defined -->';
                        break;
                    }
                    $parent = $ae[$level];
                }
            }

            $activeOnly = false;
            if (array_key_exists('activeonly', $pageparameters)) {
                $activeOnly = true;
                if (!is_bool($pageparameters['activeonly'])) $activeOnly = (int)$pageparameters['activeonly'];
            }

            $target = "";
            if (array_key_exists('target', $pageparameters)) {
                $target = $pageparameters['target'];
            }

            ob_start();
            //function printNavigation($navi = '', $activeRubric = 0, $levels = 99, $parent = 0, $activeOnly = false, $target = '')
            printNavigation('', 0, $levels, $parent, $activeOnly, $target);
            $pagereplacement = ob_get_clean();
            break; // }}}
        case 'breadcrumbs': // {{{
            $bcstart = 1;
            if (array_key_exists('start', $pageparameters)) {
                $bcstart = (int)$pageparameters['start'];
            }

            $linkCrumbs = false;
            if (array_key_exists('link', $pageparameters)) {
                $linkCrumbs = true;
            }

            $crumbDivider = '';
            if (array_key_exists('divider', $pageparameters)) {
                $crumbDivider = $pageparameters['divider'];
            }

            $target = '';
            if (array_key_exists('target', $pageparameters)) {
                $target = $pageparameters['target'];
            }

            $pagereplacement = '';
            $uls = '<ul>'; $ule = '';
            $div = '';
            $db = new DB;
            $bc = getActiveElements();
            foreach ($bc as $k=>$v) {
                $bcstart--;
                if ($bcstart>=0) continue;
                $db->query('SELECT caption, rubric_id, settings FROM '.CPO_NAVTREE.' '
                    .'WHERE id='.$v
                );
                $db->next_record();
                $pagereplacement .= $uls; // if we build a list start with <ul>
                $uls = ''; $ule = '</ul>';

                $lis = '<li>'.$div;
                $lie = '</li>';
                if ($linkCrumbs) { // {{{

                    // build link
                    $_settings = unserialize($db->v('settings'));
                    if (!is_array($_settings)) $_settings = array();

                    $link = $_settings['externalURL'];

                    $_target = $target;
                    if (!empty($_settings['externalURLTarget'])) {
                        $_target = $_settings['externalURLTarget'];
                    }

                    if ($db->v('rubric_id')!=0) {
                        foreach ($GLOBALS['cpoRubrics'] as $k=>$v) {
                            if ($v['id']!=$db->v('rubric_id')) continue;

                            if (isset($v['directory']) && $GLOBALS['cpoSystem']['PATH_INFO']) {
                                $link = BASE_URL.$v['directory'].'/index.php/'.urlencode($v['name']);
                            }

                            if (isset($v['directory']) && !$GLOBALS['cpoSystem']['PATH_INFO']) {
                                $link = BASE_URL.$v['directory'].'/index.php?rubric='.urlencode($v['name']);
                            }
                            break;
                        }
                    }

                    $lis = $lis.'<a href="'.$link.'">';
                    $lie = '</a>'.$lie;
                } // }}}

                $pagereplacement .= $lis.htmlspecialchars($db->v('caption'), ENT_COMPAT, 'ISO-8859-15').$lie;

                $div = $crumbDivider;
            }
            $pagereplacement .= $ule;
            break; // }}}
        }

        break; // }}}
    case 'value': // {{{
        if (strtolower($page_name)=='articles') {
            if (empty($articlesCount)) {
                // Artikelanzahlen fr alle Rubrik-IDs bestimmen
                $query = "SELECT rubric_id, count(rubric_id) AS artikelanzahl FROM "
                            . CPO_NEWS . " WHERE "
                            . ( $cpoSystem['release']
                            ? "artikel_archiv<2 AND freigabe=" . STATE_RELEASED
                            : "artikel_archiv<1 AND freigabe!=" . STATE_BLOCKED )
                            . " AND pub_datum<='" . date('Y-m-d H:i:s', time())
                            . "' AND verfallsdatum>='" . date('Y-m-d H:i:s', time())
                            . "' GROUP BY rubric_id ";
                $db = new DB;
                $db->query($query);
                while ($db->next_record()) {
                    $articlesCount[$db->v('rubric_id')] = $db->v('artikelanzahl');
                }
            }
            $id = $cpoRubric['id'];
            if (array_key_exists('id', $pageparameters)) {
                $id = $pageparameters['id'];
            }
            $_t = $articlesCount[$id];
            $htmlspecialchars = false;
        }

        if (strtolower($page_name)=='rubric') {
            $_t = sprintf('<a href="../%s/index.php?rubric=%s">%s</a>',
                htmlspecialchars($cpoRubric['directory'], ENT_COMPAT, 'ISO-8859-15'),
                urlencode($cpoRubric['id']),
                htmlspecialchars($cpoRubricSettings['title'], ENT_COMPAT, 'ISO-8859-15')
            );
            $htmlspecialchars = false;

            if (array_key_exists('id', $pageparameters)) {
                $_t = (int)$cpoRubric['id'];
                $htmlspecialchars = true;
            }
            if (array_key_exists('directory', $pageparameters)) {
                $_t = $cpoRubric['directory'];
                $htmlspecialchars = true;
            }
            if (array_key_exists('name', $pageparameters)) {
                $_t = $cpoRubric['name'];
                $htmlspecialchars = true;
            }
            if (array_key_exists('title', $pageparameters)) {
                $_t = $cpoRubricSettings['title'];
                $htmlspecialchars = true;
            }
            if (array_key_exists('keywords', $pageparameters)) {
                $_t = '<meta name="keywords" content="' .
                      htmlspecialchars($cpoRubricSettings['metaKeywords'], ENT_COMPAT, 'ISO-8859-15') .
                      '" />';
                if (empty($cpoRubricSettings['metaKeywords'])) {
                    $_t = '';
                }
                $htmlspecialchars = false;
            }
            if (array_key_exists('description', $pageparameters)) {
                $_t = '<meta name="description" content="' .
                      htmlspecialchars($cpoRubricSettings['metaDescription'], ENT_COMPAT, 'ISO-8859-15') .
                      '" />';
                if (empty($cpoRubricSettings['metaDescription'])) {
                    $_t = '';
                }
                $htmlspecialchars = false;
            }
        }

        if (array_key_exists('strip_tags', $pageparameters)) {
            $_t = strip_tags($_t);
        }
        if (array_key_exists('urlencode', $pageparameters)) {
            $_t = urlencode($_t);
        }
        if ($htmlspecialchars) {
            $_t = htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15');
        }

        $pagereplacement = $_t;
        break; // }}}
    case 'function': // {{{
        $page_name = 'cpoPage' . ucfirst($page_name);
        if (!function_exists($page_name)) break;
        $pagereplacement = $page_name($_params);
        break; // }}}
    }

    $pagereplacer['/'.preg_quote($page_fullmatch, '/').'/'] = $pagereplacement;
}

// do the magic pattern replacing 
if (count($pagereplacer)>0)
    $pageTemplate = preg_replace(array_keys($pagereplacer), array_values($pagereplacer), $pageTemplate);

// mod_pages ***************************************************
if (isset($activeModules['Pages'])) {
	$code = $pageTemplate;
	include(CPO_BASEDIR.$activeModules['Pages']['directory'].'/includes/parser.inc.php');
} else {
	echo $pageTemplate;
}
// mod_pages ***************************************************

